#ifndef __MinimalSimEvaluation_H__
#define __MinimalSimEvaluation_H__

#include "Evaluation.h"
#include "MotionMinimalSim.h"
#include "ImageArray.h"

#include <string>
using namespace std;

class MinimalSimEvaluation : public Evaluation<ImageArray> {

public:
	MinimalSimEvaluation();
	virtual ~MinimalSimEvaluation();
	
public:
	double evaluate( Candidate<ImageArray>& candidate );
	void initialise( int numsims = TEST_CASES );
		
public:
	static string DATA_FILE;
		
protected:
	auto_list< MotionMinimalSim > simulations_;
	int numsims_;
};

#endif // __MinimalSimEvaluation_H__
