#ifndef __MinimalSimulation_H__
#define __MinimalSimulation_H__

#include "ImageArray.h"
#include "Candidate.h"

class MinimalSimulation {

public:
	MinimalSimulation() {};
	virtual ~MinimalSimulation() {};

public:
	static double NOISE;

public:
	virtual void initialise() = 0;
	virtual double evaluate( Candidate<ImageArray>& candidate ) = 0;

};

#endif // __MinimalSimulation_H__
