#ifndef __auto_list_H__
#define __auto_list_H__

#include <vector>
using namespace std;

template<class T> class auto_list {

public:
	~auto_list() { clear(); };
	
public:
	void clear() { for ( unsigned int i = 0; i < elems_.size(); i++ ) { delete elems_[ i ]; }; elems_.clear(); };
	unsigned int size() const { return elems_.size(); };
	bool empty() const { return elems_.empty(); };
	const T& operator[]( int i ) const { return *elems_[ i ]; };
	      T& operator[]( int i )       { return *elems_[ i ]; };
		  
	void add( T* elem ) { elems_.push_back( elem ); };
	T* pop() { T* ptr = elems_.back(); elems_.pop_back(); return ptr; };
	
	vector<T*> ptrs() { return elems_; };

protected:
	vector<T*> elems_;
};

#endif // __auto_list_H__
