#ifndef __ConstantNode_H__
#define __ConstantNode_H__

#include "GPNode.h"

template<class T> class ConstantNode : public GPNode<T> {

public:
	ConstantNode( const T& c ) { output_ = c; };
	virtual ~ConstantNode() {};
	
public:
	virtual void execute() {}; 
        void print( ostream& output ) const;
        void read( istream& input ){};
};

template<class T> void ConstantNode<T>::print( ostream& output ) const {
    output << output_;
}

#endif // __ConstantNode_H__
