#ifndef __memory_pool_H__
#define __memory_pool_H__

#include <vector>
using namespace std;

class memory_pool {

public:
	~memory_pool() { for ( unsigned int i = 0; i < memory_.size(); i++ ) { ::operator delete(memory_[ i ]); }; memory_.clear(); };
	
public:
	bool empty() const { return memory_.empty(); };
	void* pop() { void* ptr = memory_.back(); memory_.pop_back(); return ptr; };
	void  push( void* ptr ) { memory_.push_back( ptr ); };

protected:
	vector<void*> memory_;

};

#endif // __memory_pool_H__
